LibreOffice: XStringResourceManager Interface Reference

LibreOffice LibreOffice 7.5 SDK API Reference

Loading...
Searching...
No Matches
Public Member Functions | List of all members
XStringResourceManager Interface Reference

Interface to manage a resource string table containing a set of strings for different locales. More...

Inheritance diagram for XStringResourceManager:

## Public Member Functions
boolean | isReadOnly ()
| Returns the resource's read only state.
void | setCurrentLocale ([in] com::sun::star::lang::Locale Locale, [in] boolean FindClosestMatch) raises ( com::sun::star::lang::IllegalArgumentException )
| Sets the locale to be used.
void | setDefaultLocale ([in] com::sun::star::lang::Locale Locale) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::NoSupportException )
| Sets the default locale to be used.
void | setString ([in] string ResourceID, [in] string Str) raises ( com::sun::star::lang::NoSupportException )
| Associates a String to a Resource ID for the current locale.
void | setStringForLocale ([in] string ResourceID, [in] string Str, [in] com::sun::star::lang::Locale locale) raises ( com::sun::star::lang::NoSupportException )
| Associates a String to a Resource ID for a specific locale.
void | removeId ([in] string ResourceID) raises ( com::sun::star::resource::MissingResourceException, com::sun::star::lang::NoSupportException )
| Removes a Resource ID including the corresponding string for the current locale.
void | removeIdForLocale ([in] string ResourceID, [in] com::sun::star::lang::Locale locale) raises ( com::sun::star::resource::MissingResourceException, com::sun::star::lang::NoSupportException )
| Removes a Resource ID including the corresponding string for s specific locale.
void | newLocale ([in] com::sun::star::lang::Locale locale) raises ( com::sun::star::container::ElementExistException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::NoSupportException )
| Creates a new locale.
void | removeLocale ([in] com::sun::star::lang::Locale locale) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::NoSupportException )
| Removes a locale completely including the corresponding strings for each locale.
long | getUniqueNumericId () raises ( com::sun::star::lang::NoSupportException )
| Provides a numeric id that is unique within all Resource IDs used in the string table.
Public Member Functions inherited from XStringResourceResolver
string | resolveString ([in] string ResourceID) raises ( com::sun::star::resource::MissingResourceException )
| Resolves the passed ResourceID for the current locale.
string | resolveStringForLocale ([in] string ResourceID, [in] com::sun::star::lang::Locale locale) raises ( com::sun::star::resource::MissingResourceException )
| Resolves the passed ResourceID for a specific locale.
boolean | hasEntryForId ([in] string ResourceID)
| Checks if the resource contains an entry for the given ResourceID and current locale.
boolean | hasEntryForIdAndLocale ([in] string ResourceID, [in] com::sun::star::lang::Locale locale)
| Checks if the resource contains an entry for the given ResourceID and locale.
sequence< string > | getResourceIDs ()
| Returns a sequence of all valid Resource IDs for the current locale.
sequence< string > | getResourceIDsForLocale ([in] com::sun::star::lang::Locale locale)
| Returns a sequence of all valid Resource IDs for a specific locale.
com::sun::star::lang::Locale | getCurrentLocale ()
| Returns the current locale specified in the accessed resource.
com::sun::star::lang::Locale | getDefaultLocale ()
| Returns the default locale of the accessed resource.
sequence< com::sun::star::lang::Locale > | getLocales ()
| Returns a sequence of all supported locales.
Public Member Functions inherited from XModifyBroadcaster
void | addModifyListener ([in] com::sun::star::util::XModifyListener aListener)
| adds the specified listener to receive events "modified."
void | removeModifyListener ([in] com::sun::star::util::XModifyListener aListener)
| removes the specified listener.
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.

## Detailed Description

Interface to manage a resource string table containing a set of strings for different locales.

The interface is derived from com::sun::star::resource::XStringResourceResolver that allows to access the string table but not to modify it. This interface also allows to modify the string table.

It's designed to be used in the context of creating a string table, e.g. from a string table editor or from a Dialog Editor designing localized dialogs.

## Member Function Documentation

## ◆ getUniqueNumericId()

long getUniqueNumericId | ( |  | ) |
raises | ( | com::sun::star::lang::NoSupportException
| ) |  |

Provides a numeric id that is unique within all Resource IDs used in the string table.

This method takes into account all Resource IDs starting with a decimal number and only evaluates the ID until the first non digit character is reached. This allows to extend unique IDs with individual identifiers without breaking the mechanism of this method.

Examples: ID "42" -> numeric id 42 ID "0foo" -> numeric id 0 ID "111.MyId.Something.Else" -> numeric id 111 ID "No Digits" -> not considered for numeric id

The id returned will be 0 for an empty string table and it will be reset to 0 if all locales are removed. In all other cases this method returns the maximum numeric id used so far at the beginning of a Resource ID incremented by 1. When calling this method more than once always the same number will be returned until this number is really used at the beginning of a new Resource ID passed to setString() or setStringForLocale().

As the numeric id is guaranteed to be unique for the complete string table all locales are taken into account. So using this methods will force the implementation to load all locale data that may not have been loaded so far.

Exceptions

  com::sun::star::lang::NoSupportException | if the next available id exceeds the range of type long. So it's not recommended to use own Resource IDs starting with a decimal number near to the maximum long value if this methods should be used.

## ◆ isReadOnly()

boolean isReadOnly | ( |  | ) |

Returns the resource's read only state.

Returns
  `TRUE` if the resource is read only, otherwise `FALSE`

## ◆ newLocale()

void newLocale | ( | [in] com::sun::star::lang::Locale | locale | ) |
raises | ( | com::sun::star::container::ElementExistException,
|  | com::sun::star::lang::IllegalArgumentException,
|  | com::sun::star::lang::NoSupportException
| ) |  |

Creates a new locale.

For each existing ResourceID an empty string will be created. The first locale created will automatically be the first default locale. Otherwise strings for all already created IDs will be copied from the default locale.

Exceptions

  com::sun::star::container::ElementExistException | if the Locale already has been created.
  com::sun::star::lang::IllegalArgumentException | if the Locale is not valid.
  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

## ◆ removeId()

void removeId | ( | [in] string | ResourceID | ) |
raises | ( | com::sun::star::resource::MissingResourceException,
|  | com::sun::star::lang::NoSupportException
| ) |  |

Removes a Resource ID including the corresponding string for the current locale.

Parameters

  ResourceID | The Resource ID to be removed for the current locale.

Exceptions

  com::sun::star::resource::MissingResourceException | if the Resource ID is not valid.
  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

## ◆ removeIdForLocale()

void removeIdForLocale | ( | [in] string | ResourceID,
|  | [in] com::sun::star::lang::Locale | locale
| ) |  |
raises | ( | com::sun::star::resource::MissingResourceException,
|  | com::sun::star::lang::NoSupportException
| ) |  |

Removes a Resource ID including the corresponding string for s specific locale.

Parameters

  ResourceID | The Resource ID to be removed.
  locale | The locale the Resource ID should be removed for. The locale has to match exactly with one of the locales provided by getLocales(). A closest match search is not supported.

Exceptions

  com::sun::star::resource::MissingResourceException | if the Resource ID is not valid.
  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

## ◆ removeLocale()

void removeLocale | ( | [in] com::sun::star::lang::Locale | locale | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException,
|  | com::sun::star::lang::NoSupportException
| ) |  |

Removes a locale completely including the corresponding strings for each locale.

Exceptions

  com::sun::star::lang::IllegalArgumentException | if the Locale to be removed is not supported.
  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

## ◆ setCurrentLocale()

void setCurrentLocale | ( | [in] com::sun::star::lang::Locale | Locale,
|  | [in] boolean | FindClosestMatch
| ) |  |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

Sets the locale to be used.

Parameters

  Locale | Specifies the current locale to be used.
  FindClosestMatch |

If true: If the exact locale that should be set is not available the method tries to find the closest match. E.g. if en_US is re- quired but not available, en would be the next choice. Finally the default locale will be used `TRUE`.

If false: If the exact locale that should be set is not available a com::sun::star::lang::IllegalArgumentException is thrown.

If false: If the exact locale that should be set is not available a com::sun::star::lang::IllegalArgumentException is thrown.

## ◆ setDefaultLocale()

void setDefaultLocale | ( | [in] com::sun::star::lang::Locale | Locale | ) |
raises | ( | com::sun::star::lang::IllegalArgumentException,
|  | com::sun::star::lang::NoSupportException
| ) |  |

Sets the default locale to be used.

Parameters

  Locale | Specifies the default locale to be used. If this locale is not available a com::sun::star::lang::IllegalArgumentException is thrown.

Exceptions

  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

## ◆ setString()

void setString | ( | [in] string | ResourceID,
|  | [in] string | Str
| ) |  |
raises | ( | com::sun::star::lang::NoSupportException
| ) |  |

Associates a String to a Resource ID for the current locale.

If an entry for the Resource ID already exists, the string associated with it will be overwritten, otherwise a new entry will be created.

Parameters

  ResourceID | ID to address the string inside the resource for the current locale.
  Str | String to be associated with the Resource ID.

Exceptions

  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

## ◆ setStringForLocale()

void setStringForLocale | ( | [in] string | ResourceID,
|  | [in] string | Str,
|  | [in] com::sun::star::lang::Locale | locale
| ) |  |
raises | ( | com::sun::star::lang::NoSupportException
| ) |  |

Associates a String to a Resource ID for a specific locale.

If an entry for the Resource ID already exists, the string associated with it will be overwritten, otherwise a new entry will be created.

It's not recommended to use this method to get the best performance as the implementation may be optimized for the use of the current locale.

Parameters

  ResourceID | ID to address the string inside the resource.
  Str | String to be associated with the Resource ID.
  locale | The locale the string should be set for. The locale has to match exactly with one of the locales provided by getLocales(). A closest match search is not supported.

Exceptions

  com::sun::star::lang::NoSupportException | if the resource is read only, see isReadOnly()

The documentation for this interface was generated from the following file:

- com/sun/star/resource/XStringResourceManager.idl